%define _default_patch_fuzz 1
%define Werror_cflags %nil

# Csound is really dumb about 64-bit
%ifarch x86_64 ia64
%define build64bit 1
%define install64bit --word64
%define useDouble 1
%else
%define build64bit 0
%define install64bit %{nil}
%define useDouble 0
%endif

Summary:       A sound synthesis language and library
Name:          csound
Version:       5.13.0
Release:       %mkrel 7
License:       LGPLv2+
Group:         Sound
URL:           http://csound.sourceforge.net/

Source0: http://downloads.sourceforge.net/csound/Csound%{version}.tar.gz
# nicked from the Fedora src.rpm
Source1: http://downloads.sourceforge.net/csound/Csound5.13-manual-src.tar.gz
Source2: http://downloads.sourceforge.net/csound/Csound5.13_manual_html.zip

Patch0: csound-fixpython.patch
Patch1: csound-5.13.0-no-usr-local.patch
Patch2: csound-5.13.0-default-opcodedir.patch
Patch3: csound-5.10.1-rtalsa-fix.patch
Patch4: csound-5.13.0-makebuild.patch
Patch5: csound-5.10.1-64-bit-plugin-path.patch
Patch6: csound-5.13.0-fix-conflicts.patch
Patch7: csound-5.13.0-fix-locale-install.patch
Patch8: csound-5.10.1-enable-oggplay.patch
Patch10: csound-default-pulse.patch
Patch11: Csound5.10-fix-tcl-check.patch
Patch12: Csound5.10-fix-includes.patch
Patch13: csound-5.11-CVE-2012-0270.patch
Patch14: csound-fix-CVE-2012-2107.patch

BuildRequires: swig scons
BuildRequires: libsndfile-devel
BuildRequires: png-devel
BuildRequires: jpeg-devel
BuildRequires: python-devel
BuildRequires: pkgconfig(alsa)
BuildRequires: libjack-devel
BuildRequires: pulseaudio-devel
BuildRequires: fluidsynth-devel
BuildRequires: liblo-devel
BuildRequires: dssi-devel
BuildRequires: lua-devel
BuildRequires: fltk-devel
BuildRequires: java-devel >= 1.4.0
BuildRequires: jpackage-utils >= 1.5
BuildRequires: java-gcj-compat-devel
BuildRequires: tk-devel
BuildRequires: tcl-devel
BuildRequires: tetex
BuildRequires: tetex-latex
BuildRequires: libxslt-devel
BuildRequires: libvorbis-devel
BuildRequires: libogg-devel
BuildRequires: gettext
BuildRequires: gcc-c++
BuildRequires: boost-devel
BuildRequires: bison flex

Obsoletes: csound-tutorial <= 5.08
Obsoletes: olpcsound <= 5.10.90

%description
Csound is a sound and music synthesis system, providing facilities for
composition and performance over a wide range of platforms. It is not
restricted to any style of music, having been used for many years in
at least classical, pop, techno, ambient...


%files -f %{name}5.lang
%defattr(-,root,root,-)
%doc COPYING ChangeLog readme-csound5.txt
%{_bindir}/atsa
%{_bindir}/cs-launcher
%{_bindir}/csb64enc
%{_bindir}/csound
%{_bindir}/cvanal
%{_bindir}/dnoise
%{_bindir}/cs-envext
%{_bindir}/cs-extract
%{_bindir}/cs-extractor
%{_bindir}/het_export
%{_bindir}/het_import
%{_bindir}/hetro
%{_bindir}/lpanal
%{_bindir}/lpc_export
%{_bindir}/lpc_import
%{_bindir}/makecsd
%{_bindir}/cs-mixer
%{_bindir}/pvanal
%{_bindir}/pvlook
%{_bindir}/cs-scale
%{_bindir}/cs-scot
%{_bindir}/scsort
%{_bindir}/cs-sndinfo
%{_bindir}/cs-srconv
%{_bindir}/pv_export
%{_bindir}/pv_import
%{_libdir}/lib%{name}.so.5.2
%{_libdir}/libcsnd.so.5.2
%dir %{_libdir}/%{name}/plugins
%{_libdir}/%{name}/plugins/libambicode1.so
%{_libdir}/%{name}/plugins/libampmidid.so
%{_libdir}/%{name}/plugins/libbabo.so
%{_libdir}/%{name}/plugins/libbarmodel.so
%{_libdir}/%{name}/plugins/libcompress.so
%{_libdir}/%{name}/plugins/libcontrol.so
%{_libdir}/%{name}/plugins/libcrossfm.so
%{_libdir}/%{name}/plugins/libchua.so
%{_libdir}/%{name}/plugins/libcs_date.so
%{_libdir}/%{name}/plugins/libcs_pan2.so
%{_libdir}/%{name}/plugins/libcs_pvs_ops.so
%{_libdir}/%{name}/plugins/libdoppler.so
%{_libdir}/%{name}/plugins/libeqfil.so
%{_libdir}/%{name}/plugins/libftest.so
%{_libdir}/%{name}/plugins/libgabnew.so
%{_libdir}/%{name}/plugins/libgrain4.so
%{_libdir}/%{name}/plugins/libhrtferX.so
%{_libdir}/%{name}/plugins/libhrtfnew.so
%{_libdir}/%{name}/plugins/libimage.so
%{_libdir}/%{name}/plugins/libjacko.so
%{_libdir}/%{name}/plugins/libloscilx.so
%{_libdir}/%{name}/plugins/libminmax.so
%{_libdir}/%{name}/plugins/libmixer.so
%{_libdir}/%{name}/plugins/libmodal4.so
%{_libdir}/%{name}/plugins/libmodmatrix.so
%{_libdir}/%{name}/plugins/libmutexops.so
%{_libdir}/%{name}/plugins/liboggplay.so
%{_libdir}/%{name}/plugins/libpartikkel.so
%{_libdir}/%{name}/plugins/libphisem.so
%{_libdir}/%{name}/plugins/libphysmod.so
%{_libdir}/%{name}/plugins/libpitch.so
%{_libdir}/%{name}/plugins/libptrack.so
%{_libdir}/%{name}/plugins/libpvlock.so
%{_libdir}/%{name}/plugins/libpvoc.so
%{_libdir}/%{name}/plugins/libpvsbuffer.so
%{_libdir}/%{name}/plugins/libpy.so
%{_libdir}/%{name}/plugins/librtalsa.so
%{_libdir}/%{name}/plugins/librtpulse.so
%{_libdir}/%{name}/plugins/libscansyn.so
%{_libdir}/%{name}/plugins/libscoreline.so
%{_libdir}/%{name}/plugins/libsfont.so
%{_libdir}/%{name}/plugins/libshape.so
%{_libdir}/%{name}/plugins/libsignalflowgraph.so
%{_libdir}/%{name}/plugins/libstackops.so
%{_libdir}/%{name}/plugins/libstdopcod.so
%{_libdir}/%{name}/plugins/libstdutil.so
%{_libdir}/%{name}/plugins/libsystem_call.so
%{_libdir}/%{name}/plugins/libtabsum.so
%{_libdir}/%{name}/plugins/libudprecv.so
%{_libdir}/%{name}/plugins/libudpsend.so
%{_libdir}/%{name}/plugins/liburandom.so
%{_libdir}/%{name}/plugins/libvbap.so
%{_libdir}/%{name}/plugins/libharmon.so
%{_libdir}/%{name}/plugins/libugakbari.so
%{_libdir}/%{name}/plugins/libvaops.so
%{_libdir}/%{name}/plugins/libvosim.so

#--------------------------------------------------------------------

%package devel
Summary: Csound development files and libraries
Group: Development/C
Requires: %{name} = %{version}-%{release}
Obsoletes: olpcsound-devel <= 5.10.90
Conflicts: %{name}-python < 5.13.0-3

%description devel
Contains headers and libraries for developing applications that use Csound.

%files devel
%defattr(-,root,root,-)
%{_includedir}/%{name}/
%{_libdir}/lib%{name}.so
%{_libdir}/libcsnd.so

#--------------------------------------------------------------------

%package python
Summary: Python Csound development files and libraries
Group: Development/Python
Requires: %{name} = %{version}-%{release}
Requires: python

%description python
Contains Python language bindings for developing Python applications that
use Csound.

%files python
%defattr(-,root,root,-)
%{_libdir}/python%{pyver}/site-packages/*

#--------------------------------------------------------------------

%package java
Summary: Java Csound support
Group: Development/Java
Requires: %{name} = %{version}-%{release}
Requires:         jpackage-utils >= 1.5
Requires:         java-1.5.0-gcj
Requires(post):   jpackage-utils >= 1.5
Requires(postun): jpackage-utils >= 1.5
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat

%description java
Contains Java language bindings for developing and running Java
applications that use Csound.

%post java
if [ -x %{_bindir}/rebuild-gcj-db ]; then
  %{_bindir}/rebuild-gcj-db
fi

%postun java
if [ -x %{_bindir}/rebuild-gcj-db ]; then
  %{_bindir}/rebuild-gcj-db
fi

%files java
%defattr(-,root,root,-)
%{_libdir}/lib_jcsound.so
%{_libdir}/%{name}/java/
%{_javadir}/csnd.jar
%attr(-,root,root) %{_libdir}/gcj/%{name}

#--------------------------------------------------------------------

%package javadoc
Summary: API documentation for Java Csound support
Group: Development/Java

%description javadoc
API documentation for the %{name}-java package.

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-java

#--------------------------------------------------------------------

%package tk
Summary: Tcl/Tk related Csound utilities
Group: Sound
Requires: %{name} = %{version}-%{release}
Requires: tcl tk

%description tk
Contains Tcl/Tk related Csound utilities

%files tk
%defattr(-,root,root,-)
%{_libdir}/%{name}/tcl/
%{_bindir}/matrix.tk
%{_bindir}/brkpt
%{_bindir}/linseg
%{_bindir}/tabdes
%{_bindir}/cstclsh
%{_bindir}/cswish

#--------------------------------------------------------------------

%package gui
Summary: A FLTK-based GUI for Csound
Group: Sound
Requires: %{name} = %{version}-%{release}
Requires: fltk xdg-utils

%description gui
Contains a FLTK-based GUI for Csound

%files gui
%defattr(-,root,root,-)
%{_bindir}/csound5gui

#--------------------------------------------------------------------

%package fltk
Summary: FLTK plugins for Csound
Group: Sound
Requires: %{name} = %{version}-%{release}
Requires: fltk

%description fltk
Contains FLTK plugins for csound

%files fltk
%defattr(-,root,root,-)
%{_libdir}/%{name}/plugins/libwidgets.so

#--------------------------------------------------------------------

%package jack
Summary: Jack Audio plugins for Csound
Group: Sound
Requires: %{name} = %{version}-%{release}
Requires: jackit

%description jack
Contains Jack Audio plugins for Csound

%files jack
%defattr(-,root,root,-)
%{_libdir}/%{name}/plugins/librtjack.so
%{_libdir}/%{name}/plugins/libjackTransport.so

#--------------------------------------------------------------------

%package fluidsynth
Summary: Fluidsyth soundfont plugin for Csound
Group: Sound
Requires: %{name} = %{version}-%{release}

%description fluidsynth
Contains Fluidsynth soundfont plugin for Csound.

%files fluidsynth
%defattr(-,root,root,-)
%{_libdir}/%{name}/plugins/libfluidOpcodes.so

#--------------------------------------------------------------------

%package dssi
Summary: Disposable Soft Synth Interface (DSSI) plugin for Csound
Group: Sound
Requires: %{name} = %{version}-%{release}
Requires: dssi

%description dssi
Disposable Soft Synth Interface (DSSI) plugin for Csound

%files dssi
%defattr(-,root,root,-)
%{_libdir}/%{name}/plugins/libdssi4cs.so

#--------------------------------------------------------------------

%package osc
Summary: Open Sound Control (OSC) plugin for Csound
Group: Sound
Requires: %{name} = %{version}-%{release}

%description osc
Open Sound Control (OSC) plugin for Csound

%files osc
%defattr(-,root,root,-)
%{_libdir}/%{name}/plugins/libosc.so

#--------------------------------------------------------------------

%package virtual-keyboard
Summary: Virtual MIDI keyboard plugin for Csound
Group: Sound
Requires: %{name} = %{version}-%{release}
Requires: fltk

%description virtual-keyboard
A virtual MIDI keyboard plugin for Csound

%files virtual-keyboard
%defattr(-,root,root,-)
%{_libdir}/%{name}/plugins/libvirtual.so

#--------------------------------------------------------------------

%package doc
Summary: Csound manual
Group: Sound
Obsoletes: %{name}-manual
Requires: %{name} = %{version}-%{release}

%description doc
Canonical Reference Manual for Csound.

%files doc
%defattr(-,root,root,-)

#--------------------------------------------------------------------

%prep
%setup -q -n Csound%{version}
%patch0 -p1 -b .fixpython
%patch1 -p1 -b .no-usr-local
%patch2 -p1 -b .default-opcodedir
%patch3 -p1 -b .rtalsa
%patch4 -p1 -b .makebuild
%patch5 -p1 -b .64-bit-plugin-path
%patch6 -p1 -b .fix-conflicts
%patch7 -p1 -b .fix-local-install
%patch8 -p1 -b .enable-oggplay
%patch10 -p1 -b .default-pulse
%patch11 -p0 -b .fix_tcl_check
%patch12 -p1 -b .includes
%patch13 -p1 -b .cve_2012_0270
%patch14 -p1 -b .cve_2012_2107
tar xf %{SOURCE1}
(cd manual; unzip -q %{SOURCE2})

%build

# Adjust location of the documentation for the GUI bits
sed -ie 's#\"firefox /usr/local/share/doc/csound/manual/#\"xdg-open file://%{_docdir}/%{name}-manual-%{version}/#' \
      frontends/fltk_gui/CsoundGlobalSettings.cpp

scons dynamicCsoundLibrary=1 \
      buildRelease=0 \
      noDebug=0 \
      disableGStabs=1 \
      buildInterfaces=1 \
      useGettext=1 \
      useALSA=1 \
      usePortAudio=0 \
      usePortMIDI=0 \
      useOGG=1 \
      useOSC=1 \
      useJack=1 \
      useFLTK=1 \
      buildVirtual=1 \
      useFluidsynth=1 \
      generatePdf=0 \
      buildCsound5GUI=1 \
      pythonVersion=%{py_ver} \
      buildPythonOpcodes=1 \
      buildPythonWrapper=1 \
      buildLuaWrapper=1 \
      buildTclcsound=1 \
      buildJavaWrapper=1 \
      buildDSSI=1 \
      buildUtilities=1 \
      prefix=%{_prefix} \
      customCCFLAGS="%{optflags}" \
      customCXXFLAGS="%{optflags}" \
      Word64=%{build64bit} \
      useDouble=%{useDouble}

# Generate javadoc
(cd interfaces; javadoc *.java)

%install
%{__rm} -rf %{buildroot}
%{__python} install.py --prefix=%{_prefix} --instdir=%{buildroot} %{install64bit}
%{__rm} -f %{buildroot}%{_docdir}/%{name}/COPYING
%{__rm} -f %{buildroot}%{_docdir}/%{name}/ChangeLog
%{__rm} -f %{buildroot}%{_docdir}/%{name}/INSTALL
%{__rm} -f %{buildroot}%{_docdir}/%{name}/readme-csound5.txt
%{__rm} -f %{buildroot}%{_bindir}/uninstall-csound5
%{__rm} -f %{buildroot}%{_prefix}/csound5-*.md5sums

# This file is zero-lenth for some reason
%{__rm} -f manual/examples/ifthen.csd
# Remove the CVS dir in examples
%{__rm} -rf manual/examples/CVS

install -dm 755 %{buildroot}%{_javadir}
(cd %{buildroot}%{_javadir}; ln -s %{_libdir}/%{name}/java/csnd.jar .)

install -dm 644 %{buildroot}%{_javadocdir}/%{name}-java
%{__chmod} -R 755 %{buildroot}%{_javadocdir}/%{name}-java
(cd interfaces; tar cf - *.html csnd/*.html) | (cd %{buildroot}%{_javadocdir}/%{name}-java; tar xvf -)

%{_bindir}/aot-compile-rpm

%find_lang %{name}5

%clean
%{__rm} -rf %{buildroot}




%changelog

* Tue Apr 24 2012 fwang <fwang> 5.13.0-7.mga2
+ Revision: 233147
- add patch fixing CVE-2012-210[678]
- drop linkflaggs
- try build with ldflags

* Sat Apr 07 2012 fwang <fwang> 5.13.0-5.mga2
+ Revision: 229474
- fix typo
- add upstream patch to fix CVE-2012-0270: two buffer overflow flaws in getnum()

* Mon Sep 19 2011 fwang <fwang> 5.13.0-4.mga2
+ Revision: 145280
- rebuild for new libpng

* Mon Jul 11 2011 ahmad <ahmad> 5.13.0-3.mga2
+ Revision: 122089
- Move libcsnd.so to the -devel package

* Mon Jul 11 2011 fwang <fwang> 5.13.0-2.mga2
+ Revision: 122088
- rebuild for new fltk

* Sun Jul 10 2011 ahmad <ahmad> 5.13.0-1.mga2
+ Revision: 121758
- Update the manual sources (from the Fedora src.rpm)
- Update to 5.13.0
- Rediff patch0,1,2,4,6,7,10
- Drop patch9, fixed upstream
- Add BR flex, bison
- Update the file list

* Sun Jul 03 2011 fwang <fwang> 5.11-8.mga2
+ Revision: 117572
- we use 8.5 now by default
- rebuild for new csound

* Sun Feb 20 2011 eandry <eandry> 5.11-7.mga1
+ Revision: 54675
- drop buildroot
- bump release for upgrade
- imported package csound


* Sun Nov 07 2010 Jani Välimaa <wally@mandriva.org> 5.11-6mdv2011.0
+ Revision: 594452
- recognize python 2.7
- rebuild for python 2.7

* Sat Jan 16 2010 Funda Wang <fwang@mandriva.org> 5.11-5mdv2010.1
+ Revision: 492228
- rebuild for new libjpegv8

* Fri Jan 08 2010 Frederik Himpe <fhimpe@mandriva.org> 5.11-4mdv2010.1
+ Revision: 487725
- rebuild

* Sun Jan 03 2010 Emmanuel Andry <eandry@mandriva.org> 5.11-3mdv2010.1
+ Revision: 486025
- rebuild for new fltk

* Thu Nov 26 2009 Jérôme Brenier <incubusss@mandriva.org> 5.11-2mdv2010.1
+ Revision: 470418
-jack subpackage : requires jackit instead of jack-audio-connection-kit

* Sat Nov 07 2009 Frederik Himpe <fhimpe@mandriva.org> 5.11-1mdv2010.1
+ Revision: 462689
- update to new version 5.11

* Thu Oct 08 2009 Guillaume Rousse <guillomovitch@mandriva.org> 5.10.1-3mdv2010.0
+ Revision: 456003
- fix groups
- rename -manual subpackage to -doc
- don't make it noarch, it doesn't work

* Sun Sep 20 2009 Nicolas Lécureuil <nlecureuil@mandriva.com> 5.10.1-2mdv2010.0
+ Revision: 446059
- Fix groups
- Fix obsoletes
- Let my "monk" packaging habits fix my spec files :)
- Fix file list
- import csound

